Index: trunk/kernel/kern/metafs.h
===================================================================
--- trunk/kernel/kern/metafs.h	(revision 1)
+++ trunk/kernel/kern/metafs.h	(revision 1)
@@ -0,0 +1,245 @@
+/*
+ * metafs.h - Meta File-System manages parent-child accesses
+ * 
+ * Authors   Ghassan Almaless (2008,2009,2010,2011,2012)
+ *           Alain Greiner    (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _METAFS_H_
+#define _METAFS_H_
+
+#include <almos_config.h>
+#include <hal_types.h>
+#include <list.h>
+#include <string.h>
+
+#define METAFS_HASH_SIZE    10
+
+/******************************************************************************************
+ * This structure define a node in the metafs tree.
+ *****************************************************************************************/
+
+typedef struct metafs_s
+{
+	char        * name;                         /*! name represented by this node        */
+	uint32_t      children_nr;                  /*! number of chidren for this node      */
+	list_entry_t  list;                         /*! child : member of a children list    */     
+	list_entry_t  hash_tbl[METAFS_HASH_SIZE];   /*! parent : array of roots of children  */
+                                                /*!          lists, sorted by key value  */
+}
+metafs_t;
+
+/******************************************************************************************
+ * This function compute the hash key for a given name.
+ ******************************************************************************************
+ * @ name     : string to be analysed.
+ * return the key value, from 0 to (METAFS_HASH_SIZE - 1)
+ *****************************************************************************************/
+static inline uint32_t metafs_hash_index( char * dev_name )
+{
+	register char    * str   = dev_name;
+	register uint32_t  index = 0;
+  
+	while(*str)
+		index = index + (*(str++) ^ index);
+
+	return index % METAFS_HASH_SIZE;
+}
+
+/******************************************************************************************
+ * This function initializes a node with zero children.
+ ******************************************************************************************
+ * @ node     : pointer on node to be initialized.
+ * @ name     : name for this node.
+ *****************************************************************************************/
+static inline void metafs_init( metafs_t * node,
+                                char     * name )
+{
+	register uint32_t i;
+  
+	node->name        = name;
+	node->children_nr = 0;
+
+	for(i=0; i < METAFS_HASH_SIZE; i++)
+		list_root_init( &node->hash_tbl[i] );  
+}
+
+/******************************************************************************************
+ * This function register a children metafs node in a parent metafs node
+ ******************************************************************************************
+ * @ parent   : pointer on parent node.
+ * @ child    : pointer on child node.
+ *****************************************************************************************/
+static inline void metafs_register( metafs_t * parent,
+                                    metafs_t * child )
+{
+	register uint32_t index;
+  
+	parent->children_nr ++;
+	index = metafs_hash_index( child->name );
+	list_add_last( &parent->hash_tbl[index], &child->list );
+}
+
+/******************************************************************************************
+ * This function search a child node by its name in a parent node.
+ ******************************************************************************************
+ * @ parent   : pointer on parent node.
+ * @ child    : pointer on child node.
+ * @ return pointer on child node if found / return NULL if not found.
+ *****************************************************************************************/
+static inline  metafs_t * metafs_lookup( metafs_t * parent,
+                                         char     * name )
+{
+	register  list_entry_t * iter;
+	register  metafs_t     * current;
+	register  uint32_t       index;
+
+	index = metafs_hash_index(name);
+
+	LIST_FOREACH( &parent->hash_tbl[index] , iter )
+	{
+		current = LIST_ELEMENT ( iter ,  metafs_t , list );
+		if( strcmp( current->name , name ) != 0 ) return current;
+	}
+	return NULL;
+}
+
+/******************************************************************************************
+ * This function remove a child from the children list of a parent node.
+ ******************************************************************************************
+ * @ parent   : pointer on parent node.
+ * @ child    : pointer on child node.
+ *****************************************************************************************/
+static inline void metafs_unregister( metafs_t * parent,
+                                      metafs_t * child )
+{
+    list_unlink( &child->list );
+	parent->children_nr --;
+}
+
+
+
+
+
+#define metafs_get_name(_node) ((_node)->name)
+
+#define metafs_set_name(_node, _ptr) do{(_node)->name = (_ptr);}while(0)
+
+#define metafs_get_children_nr(_parent) ((_parent)->children_nr)
+
+#define metafs_hasChild(_parent) ((_parent)->children_nr != 0)
+
+#define metafs_container(_metafs, _type, _member)	\
+	list_container(_metafs, _type, _member)
+
+
+#if CONFIG_METAFS_DEBUG
+#include <kdmsg.h>
+
+static inline void metafs_print( metafs_t * node )
+{
+	uint32_t       i;
+	list_entry_t * iter;
+  
+	printk("metafs_print [%s]\n", node->name);
+  
+	for(i=0; i<METAFS_HASH_SIZE; i++)
+	{
+		printk(DEBUG, "Entry %d: ", i);
+		list_foreach(&node->hash_tbl[i], iter)
+		{
+			printk(DEBUG, "%s, ", list_element(iter,  metafs_t, list)->name);
+		}
+		printk(DEBUG, "\n");
+	}
+}
+#else
+static inline void metafs_print( metafs_t * node )
+{
+}
+#endif	/* CONFIG_METAFS_DEBUG */
+
+/* deprecated
+
+////////////////////////////
+typedef struct metafs_iter_s
+{
+	uint32_t   hash_index;
+	metafs_t * current;
+}
+metafs_iter_t;
+
+
+//////////////////////////////////////////////////////////
+static inline void metafs_iter_init( metafs_t      * node,
+                                     metafs_iter_t * iter )
+{
+	register uint32_t i;
+
+	for(i=0; i < METAFS_HASH_SIZE; i++)
+	{
+		if( !(list_is_empty( &node->hash_tbl[i] ) ) )
+		{
+			iter->hash_index = i;
+			iter->current = LIST_FIRST( &node->hash_tbl[i] ,  metafs_t , list );
+			return;
+		}
+	}
+
+	iter->current = NULL;
+}
+
+/////////////////////////////////////////////////////////////////////
+static inline  metafs_t * metafs_lookup_next( metafs_t      * parent,
+                                              metafs_iter_t * iter )
+{
+	register  list_entry_t * next;
+	register  metafs_t     * child;
+	register  uint32_t       i;
+
+	if(iter->current == NULL)
+		return NULL;
+
+	child = iter->current;
+	i = iter->hash_index;
+
+	if((next = list_next(&parent->hash_tbl[i], &iter->current->list)) == NULL)
+	{ 
+		for(i = i + 1; i < METAFS_HASH_SIZE; i++)
+		{
+			if(!(list_empty(&parent->hash_tbl[i])))
+			{
+				iter->hash_index = i;
+				iter->current = list_first(&parent->hash_tbl[i],  metafs_t, list);
+				return child;
+			}
+		}
+		iter->current = NULL;
+		return child;
+	}
+   
+	iter->current = list_element(next,  metafs_t, list);
+	return child;
+}
+
+*/
+
+
+#endif	/* _METAFS_H_ */
Index: trunk/kernel/kern/mwmr.c
===================================================================
--- trunk/kernel/kern/mwmr.c	(revision 1)
+++ trunk/kernel/kern/mwmr.c	(revision 1)
@@ -0,0 +1,174 @@
+/*
+ * kern/mwmr.c - a basic FIFO buffer
+ * 
+ * Copyright (c) 2007,2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <errno.h>
+#include <mwmr.h>
+#include <kmem.h>
+#include <thread.h>
+#include <spinlock.h>
+
+struct fifomwmr_s
+{
+	spinlock_t lock;
+	uint_t isAtomic;
+	uint_t status;
+	uint_t read_ptr;
+	uint_t write_ptr;
+	char *data;
+	uint_t item;
+	uint_t length;
+};
+
+struct fifomwmr_s* mwmr_init(int item, int length, int isAtomic)
+{
+	kmem_req_t req;
+	struct fifomwmr_s *fifo;
+	char *data;
+
+	req.type  = KMEM_GENERIC;
+	req.size  = sizeof(*fifo);
+	req.flags = AF_BOOT | AF_ZERO;
+  
+	if((fifo = kmem_alloc(&req)) == NULL)
+		return NULL;
+  
+	req.size = sizeof (unsigned int) * item * length;
+
+	if((data = kmem_alloc(&req)) == NULL)
+	{
+		printk(WARNING, "WARNING: mwmr_init: MEMORY SHORTAGE\n");
+		req.ptr = fifo;
+		kmem_free(&req);
+		return NULL;
+	}
+
+	spinlock_init(&fifo->lock, "MWMR");
+	fifo->isAtomic = isAtomic;
+	fifo->item     = item;
+	fifo->length   = length * item;
+	fifo->data     = data;
+  
+	return fifo;
+}
+
+int mwmr_read(struct fifomwmr_s *fifo, void *buffer, size_t size)
+{
+	register int rnum;                    // number of words to read
+	register char *src;
+	register int i, size1, size2;
+	register char *buff = (char *) buffer;
+
+	if (size == 0)
+		return 0;
+
+	if(fifo->isAtomic)
+		spinlock_lock(&fifo->lock);
+
+	rnum = (size > fifo->status) ? fifo->status : size;
+
+	if (rnum)
+	{
+		src = fifo->data + fifo->read_ptr;
+		if ((fifo->read_ptr + rnum) <= fifo->length)
+			for (i = 0; i < rnum; i++)
+				buff[i] = src[i];
+		else
+		{
+			size1 = fifo->length - fifo->read_ptr;
+			size2 = rnum - size1;
+
+			for (i = 0; i < size1; i++)
+				buff[i] = src[i];
+
+			for (i = 0; i < size2; i++)
+				buff[size1 + i] = *(fifo->data + i);
+		}
+
+		fifo->status  -= rnum;
+		fifo->read_ptr = (fifo->read_ptr + rnum) % fifo->length;
+	}
+
+	if(fifo->isAtomic)
+		spinlock_unlock(&fifo->lock);
+
+	return rnum;
+}
+
+int mwmr_write(struct fifomwmr_s *fifo, void *buffer, size_t size)
+{
+	register int free_space;
+	register int wnum;                    // number of words to write
+	register char *dest;
+	register int i, size1, size2;
+	register char *buff = (char *) buffer;
+
+	if (size == 0)
+		return 0;
+
+	if(fifo->isAtomic)
+		spinlock_lock (&fifo->lock);
+
+	free_space = fifo->length - fifo->status;
+	wnum       = (size > free_space) ? free_space : size;
+
+	if (wnum)
+	{
+		dest = (fifo->data + fifo->write_ptr);
+
+		if ((fifo->write_ptr + wnum) <= fifo->length)
+			for (i = 0; i < wnum; i++)
+				dest[i] = buff[i];
+		else
+		{
+			size1 = fifo->length - fifo->write_ptr;
+			size2 = wnum - size1;
+
+			for (i = 0; i < size1; i++)
+				dest[i] = buff[i];
+
+			for (i = 0; i < size2; i++)
+				*(fifo->data + i) = buff[size1 + i];
+		}
+
+		fifo->status += wnum;
+		fifo->write_ptr = (fifo->write_ptr + wnum) % fifo->length;
+	}
+
+	if(fifo->isAtomic)
+		spinlock_unlock(&fifo->lock);
+
+	return wnum;
+}
+
+void mwmr_destroy(struct fifomwmr_s *fifo)
+{
+	kmem_req_t req;
+  
+	if(fifo == NULL) return;
+
+	req.type = KMEM_GENERIC;
+	req.ptr  = fifo->data;
+	kmem_free(&req);
+  
+	req.ptr  = fifo;
+	kmem_free(&req);
+}
Index: trunk/kernel/kern/mwmr.h
===================================================================
--- trunk/kernel/kern/mwmr.h	(revision 1)
+++ trunk/kernel/kern/mwmr.h	(revision 1)
@@ -0,0 +1,35 @@
+/*
+ * kern/mwmr.h - a basic FIFO buffer
+ * 
+ * Copyright (c) 2007,2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ * 
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _MWMR_H_
+#define _MWMR_H_
+
+#include <types.h>
+
+struct fifomwmr_s;
+
+struct fifomwmr_s* mwmr_init(int item, int length, int isAtomic);
+int mwmr_read(struct fifomwmr_s *fifo, void *buffer, size_t size);
+int mwmr_write(struct fifomwmr_s *fifo, void *buffer, size_t size);
+void mwmr_destroy(struct fifomwmr_s *fifo);
+
+#endif	/* _MWMR_H_ */
